"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const GenrateStoreObj_1 = require("./GenrateStoreObj");
const const_1 = require("./const");
function fetchQuery(url, method, header, data = null) {
    return new Promise((resolve, reject) => {
        let fetchData = {
            method: method,
            headers: header
        };
        if (data) {
            fetchData["body"] = JSON.stringify(data);
        }
        fetch(url, fetchData)
            .then((res) => res.json())
            .then((result) => {
            resolve(result);
        })
            .catch((err) => {
            reject(err);
        });
    });
}
class Curd {
    constructor(url, path, header) {
        this.fetchCall = fetchQuery;
        this.url = url;
        this.path = path;
        this.header = header;
    }
    add(entity) {
        let x = (0, GenrateStoreObj_1.checkValidationDefination)(entity[const_1.ENTITY.DEFINATION], entity);
        if (x.error) {
            return Promise.reject(x);
        }
        else {
            return fetchQuery(this.url + this.path, const_1.REQUEST_METHOD.POST, this.header, x.data);
        }
    }
    update(entity) {
        let x = (0, GenrateStoreObj_1.checkValidationDefination)(entity[const_1.ENTITY.DEFINATION], entity);
        if (x.error) {
            return Promise.reject(x);
        }
        else {
            return fetchQuery(this.url + this.path, const_1.REQUEST_METHOD.PUT, this.header, x.data);
        }
    }
    delete(entity) {
        let x = (0, GenrateStoreObj_1.checkValidationDefination)(entity[const_1.ENTITY.DEFINATION], entity);
        if (x.error) {
            return Promise.reject(x);
        }
        else {
            return fetchQuery(this.url + this.path, const_1.REQUEST_METHOD.DELETE, this.header, x.data);
        }
    }
    getAll() {
        return fetchQuery(this.url + this.path, const_1.REQUEST_METHOD.GET, this.header);
    }
    getById(id) {
        return fetchQuery(this.url + this.path + "/" + id, const_1.REQUEST_METHOD.GET, this.header);
    }
    getCall(path) {
        return fetchQuery(this.url + path, const_1.REQUEST_METHOD.GET, this.header);
    }
    postCall(path, data) {
        return fetchQuery(this.url + path, const_1.REQUEST_METHOD.POST, this.header);
    }
    putCall(path, data) {
        return fetchQuery(this.url + path, const_1.REQUEST_METHOD.PUT, this.header);
    }
    deleteCall(path, data) {
        return fetchQuery(this.url + path, const_1.REQUEST_METHOD.PUT, this.header);
    }
}
exports.default = Curd;
//# sourceMappingURL=HttpCurd.js.map